/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { ValueAxisLabelLocation_$type } from "./ValueAxisLabelLocation";
import { AngleAxisLabelLocation_$type } from "./AngleAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var RadialBaseChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseChart, _super);
    function RadialBaseChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.zc = null;
        _this.zd = null;
        _this.zr = 0;
        _this.zt = 5;
        _this.zs = 0;
        _this.zq = 5;
        _this.z8 = 5;
        _this.aaa = 0;
        _this.z9 = 5;
        _this.z7 = 0;
        _this.ae1 = null;
        _this.ae8 = null;
        _this.aez = null;
        _this.ae0 = null;
        _this.z2 = 0;
        _this.aaj = 0;
        _this.z1 = NaN;
        _this.aai = NaN;
        _this.z4 = NaN;
        _this.aal = NaN;
        _this.z3 = NaN;
        _this.aak = NaN;
        _this.z0 = NaN;
        _this.aah = NaN;
        _this.ae7 = null;
        _this.afe = null;
        _this.abt = null;
        _this.abx = null;
        _this.abv = null;
        _this.abz = null;
        _this.abo = null;
        _this.abp = null;
        _this.ae2 = null;
        _this.ae9 = null;
        _this.zu = DeviceUtils.g(1);
        _this.aab = DeviceUtils.g(1);
        _this.zv = DeviceUtils.g(1);
        _this.aac = DeviceUtils.g(1);
        _this.ae4 = null;
        _this.afb = null;
        _this.ae5 = null;
        _this.afc = null;
        _this.zw = DeviceUtils.g(1);
        _this.aad = DeviceUtils.g(1);
        _this.zx = DeviceUtils.g(8);
        _this.aae = 0;
        _this.ae6 = null;
        _this.afd = null;
        _this.zy = DeviceUtils.g(1);
        _this.aaf = DeviceUtils.g(1);
        _this.abu = null;
        _this.aby = null;
        _this.ae3 = null;
        _this.afa = null;
        _this.zp = 0;
        _this.z6 = 0;
        _this.zo = NaN;
        _this.z5 = NaN;
        _this.zz = 0;
        _this.aag = -90;
        _this.zk = false;
        _this.zl = false;
        _this.aeu = 1;
        _this.afx = 1;
        _this.aet = 1;
        _this.aev = 2;
        _this.afv = 0;
        _this.afw = 1;
        _this.af1 = 0;
        _this.af2 = 0;
        _this.zi = 4;
        _this.y8 = 4;
        _this.abs = null;
        _this.y4 = null;
        _this.abw = null;
        _this.y5 = null;
        return _this;
    }
    RadialBaseChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.za();
            var c = this.zb();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    RadialBaseChart.prototype.ur = function () {
        _super.prototype.ur.call(this);
        var a = this.za();
        var b = this.zb();
        if (a != null && a.az != null) {
            this.afh = a.az.textColor;
        }
        if (b != null && b.az != null) {
            this.afo = b.az.textColor;
        }
        this.afm = AxisDefaults.j;
        this.aft = AxisDefaults.j;
        this.afi = AxisDefaults.h;
        this.afp = AxisDefaults.h;
        this.afl = AxisDefaults.g;
        this.afs = AxisDefaults.g;
    };
    RadialBaseChart.prototype.vi = function (a, b, c) {
        var _this = this;
        _super.prototype.vi.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelLeftMargin":
                this.ael(function (d) { return d.leftMargin = _this.aap; });
                break;
            case "AngleAxisLabelTopMargin":
                this.ael(function (d) { return d.topMargin = _this.aar; });
                break;
            case "AngleAxisLabelRightMargin":
                this.ael(function (d) { return d.rightMargin = _this.aaq; });
                break;
            case "AngleAxisLabelBottomMargin":
                this.ael(function (d) { return d.bottomMargin = _this.aao; });
                break;
            case "ValueAxisLabelLeftMargin":
                this.aeq(function (d) { return d.leftMargin = _this.aba; });
                break;
            case "ValueAxisLabelTopMargin":
                this.aeq(function (d) { return d.topMargin = _this.abc; });
                break;
            case "ValueAxisLabelRightMargin":
                this.aeq(function (d) { return d.rightMargin = _this.abb; });
                break;
            case "ValueAxisLabelBottomMargin":
                this.aeq(function (d) { return d.bottomMargin = _this.aa9; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.aff = this.x4(this.afh);
                this.afg = this.x4(this.afo);
                break;
            case "AngleAxisLabelTextColor":
                this.aff = this.x4(this.afh);
                break;
            case "ValueAxisLabelTextColor":
                this.afg = this.x4(this.afo);
                break;
            case "ActualAngleAxisLabelTextColor":
                this.ael(function (d) { return d.textColor = _this.aff; });
                break;
            case "ActualValueAxisLabelTextColor":
                this.aeq(function (d) { return d.textColor = _this.afg; });
                break;
            case "AngleAxisTitleMargin":
                this.aen(function (d) { return d.margin = _this.aa0; });
                break;
            case "ValueAxisTitleMargin":
                this.aes(function (d) { return d.margin = _this.abl; });
                break;
            case "AngleAxisTitleLeftMargin":
                this.aen(function (d) { return d.leftMargin = _this.aaz; });
                break;
            case "ValueAxisTitleLeftMargin":
                this.aes(function (d) { return d.leftMargin = _this.abk; });
                break;
            case "AngleAxisTitleTopMargin":
                this.aen(function (d) { return d.topMargin = _this.aa2; });
                break;
            case "ValueAxisTitleTopMargin":
                this.aes(function (d) { return d.topMargin = _this.abn; });
                break;
            case "AngleAxisTitleRightMargin":
                this.aen(function (d) { return d.rightMargin = _this.aa1; });
                break;
            case "ValueAxisTitleRightMargin":
                this.aes(function (d) { return d.rightMargin = _this.abm; });
                break;
            case "AngleAxisTitleBottomMargin":
                this.aen(function (d) { return d.bottomMargin = _this.aay; });
                break;
            case "ValueAxisTitleBottomMargin":
                this.aes(function (d) { return d.bottomMargin = _this.abj; });
                break;
            case "AngleAxisTitleTextColor":
                this.aen(function (d) { return d.textColor = _this.afn; });
                break;
            case "ValueAxisTitleTextColor":
                this.aes(function (d) { return d.textColor = _this.afu; });
                break;
            case "AngleAxisFormatLabel":
                this.aej(function (d) { return d.au = _this.ze; });
                break;
            case "ValueAxisFormatLabel":
                this.aeo(function (d) { return d.au = _this.zf; });
                break;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "ze", {
        get: function () {
            return this.zc;
        },
        set: function (a) {
            var b = this.ze;
            if (a != b) {
                this.zc = a;
                this.vf("AngleAxisFormatLabel", b, this.ze);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "zf", {
        get: function () {
            return this.zd;
        },
        set: function (a) {
            var b = this.zf;
            if (a != b) {
                this.zd = a;
                this.vf("ValueAxisFormatLabel", b, this.zf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aap", {
        get: function () {
            return this.zr;
        },
        set: function (a) {
            var b = this.aap;
            if (a != b) {
                this.zr = a;
                this.vf("AngleAxisLabelLeftMargin", b, this.aap);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aar", {
        get: function () {
            return this.zt;
        },
        set: function (a) {
            var b = this.aar;
            if (a != b) {
                this.zt = a;
                this.vf("AngleAxisLabelTopMargin", b, this.aar);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aaq", {
        get: function () {
            return this.zs;
        },
        set: function (a) {
            var b = this.aaq;
            if (a != b) {
                this.zs = a;
                this.vf("AngleAxisLabelRightMargin", b, this.aaq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aao", {
        get: function () {
            return this.zq;
        },
        set: function (a) {
            var b = this.aao;
            if (a != b) {
                this.zq = a;
                this.vf("AngleAxisLabelBottomMargin", b, this.aao);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aba", {
        get: function () {
            return this.z8;
        },
        set: function (a) {
            var b = this.aba;
            if (a != b) {
                this.z8 = a;
                this.vf("ValueAxisLabelLeftMargin", b, this.aba);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abc", {
        get: function () {
            return this.aaa;
        },
        set: function (a) {
            var b = this.abc;
            if (a != b) {
                this.aaa = a;
                this.vf("ValueAxisLabelTopMargin", b, this.abc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abb", {
        get: function () {
            return this.z9;
        },
        set: function (a) {
            var b = this.abb;
            if (a != b) {
                this.z9 = a;
                this.vf("ValueAxisLabelRightMargin", b, this.abb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa9", {
        get: function () {
            return this.z7;
        },
        set: function (a) {
            var b = this.aa9;
            if (a != b) {
                this.z7 = a;
                this.vf("ValueAxisLabelBottomMargin", b, this.aa9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afh", {
        get: function () {
            return this.ae1;
        },
        set: function (a) {
            var b = this.afh;
            if (a != b) {
                this.ae1 = a;
                this.vf("AngleAxisLabelTextColor", b, this.afh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afo", {
        get: function () {
            return this.ae8;
        },
        set: function (a) {
            var b = this.afo;
            if (a != b) {
                this.ae8 = a;
                this.vf("ValueAxisLabelTextColor", b, this.afo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aff", {
        get: function () {
            return this.aez;
        },
        set: function (a) {
            var b = this.aez;
            if (a != b) {
                this.aez = a;
                this.vf("ActualAngleAxisLabelTextColor", b, this.aff);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afg", {
        get: function () {
            return this.ae0;
        },
        set: function (a) {
            var b = this.ae0;
            if (a != b) {
                this.ae0 = a;
                this.vf("ActualValueAxisLabelTextColor", b, this.afg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa0", {
        get: function () {
            return this.z2;
        },
        set: function (a) {
            var b = this.aa0;
            if (a != b) {
                this.z2 = a;
                this.vf("AngleAxisTitleMargin", b, this.aa0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abl", {
        get: function () {
            return this.aaj;
        },
        set: function (a) {
            var b = this.abl;
            if (a != b) {
                this.aaj = a;
                this.vf("ValueAxisTitleMargin", b, this.abl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aaz", {
        get: function () {
            return this.z1;
        },
        set: function (a) {
            var b = this.aaz;
            if (a != b) {
                this.z1 = a;
                this.vf("AngleAxisTitleLeftMargin", b, this.aaz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abk", {
        get: function () {
            return this.aai;
        },
        set: function (a) {
            var b = this.abk;
            if (a != b) {
                this.aai = a;
                this.vf("ValueAxisTitleLeftMargin", b, this.abk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa2", {
        get: function () {
            return this.z4;
        },
        set: function (a) {
            var b = this.aa2;
            if (a != b) {
                this.z4 = a;
                this.vf("AngleAxisTitleTopMargin", b, this.aa2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abn", {
        get: function () {
            return this.aal;
        },
        set: function (a) {
            var b = this.abn;
            if (a != b) {
                this.aal = a;
                this.vf("ValueAxisTitleTopMargin", b, this.abn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa1", {
        get: function () {
            return this.z3;
        },
        set: function (a) {
            var b = this.aa1;
            if (a != b) {
                this.z3 = a;
                this.vf("AngleAxisTitleRightMargin", b, this.aa1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abm", {
        get: function () {
            return this.aak;
        },
        set: function (a) {
            var b = this.abm;
            if (a != b) {
                this.aak = a;
                this.vf("ValueAxisTitleRightMargin", b, this.abm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aay", {
        get: function () {
            return this.z0;
        },
        set: function (a) {
            var b = this.aay;
            if (a != b) {
                this.z0 = a;
                this.vf("AngleAxisTitleBottomMargin", b, this.aay);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abj", {
        get: function () {
            return this.aah;
        },
        set: function (a) {
            var b = this.abj;
            if (a != b) {
                this.aah = a;
                this.vf("ValueAxisTitleBottomMargin", b, this.abj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afn", {
        get: function () {
            return this.ae7;
        },
        set: function (a) {
            var b = this.afn;
            if (a != b) {
                this.ae7 = a;
                this.vf("AngleAxisTitleTextColor", b, this.afn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afu", {
        get: function () {
            return this.afe;
        },
        set: function (a) {
            var b = this.afu;
            if (a != b) {
                this.afe = a;
                this.vf("ValueAxisTitleTextColor", b, this.afu);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.vj = function (a, b, c) {
        var _this = this;
        _super.prototype.vj.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelTextStyle":
                this.ael(function (d) { return d.textStyle = _this.acg; });
                break;
            case "ValueAxisLabelTextStyle":
                this.aeq(function (d) { return d.textStyle = _this.adm; });
                break;
            case "AngleAxisTitleTextStyle":
                this.aen(function (d) { return d.textStyle = _this.ac4; });
                break;
            case "ValueAxisTitleTextStyle":
                this.aes(function (d) { return d.textStyle = _this.aea; });
                break;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "acg", {
        get: function () {
            return this.abt;
        },
        set: function (a) {
            var b = this.acg;
            if (a != b) {
                this.abt = a;
                this.vf("AngleAxisLabelTextStyle", b, this.acg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "adm", {
        get: function () {
            return this.abx;
        },
        set: function (a) {
            var b = this.adm;
            if (a != b) {
                this.abx = a;
                this.vf("ValueAxisLabelTextStyle", b, this.adm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ac4", {
        get: function () {
            return this.abv;
        },
        set: function (a) {
            var b = this.ac4;
            if (a != b) {
                this.abv = a;
                this.vf("AngleAxisTitleTextStyle", b, this.ac4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aea", {
        get: function () {
            return this.abz;
        },
        set: function (a) {
            var b = this.aea;
            if (a != b) {
                this.abz = a;
                this.vf("ValueAxisTitleTextStyle", b, this.aea);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.aeg = function (a) {
        var _this = this;
        this.aed(a, function (b) { return b.leftMargin = _this.aap; });
        this.aed(a, function (b) { return b.topMargin = _this.aar; });
        this.aed(a, function (b) { return b.rightMargin = _this.aaq; });
        this.aed(a, function (b) { return b.bottomMargin = _this.aao; });
        this.aed(a, function (b) { return b.textColor = _this.aff; });
        this.aee(a, function (b) { return b.textColor = _this.afn; });
        this.aee(a, function (b) { return b.leftMargin = _this.aaz; });
        this.aee(a, function (b) { return b.topMargin = _this.aa2; });
        this.aee(a, function (b) { return b.rightMargin = _this.aa1; });
        this.aee(a, function (b) { return b.bottomMargin = _this.aay; });
        this.aed(a, function (b) { return b.textStyle = _this.acg; });
        this.aee(a, function (b) { return b.textStyle = _this.ac4; });
    };
    RadialBaseChart.prototype.aei = function (a) {
        var _this = this;
        this.aed(a, function (b) { return b.leftMargin = _this.aba; });
        this.aed(a, function (b) { return b.topMargin = _this.abc; });
        this.aed(a, function (b) { return b.rightMargin = _this.abb; });
        this.aed(a, function (b) { return b.bottomMargin = _this.aa9; });
        this.aed(a, function (b) { return b.textColor = _this.afg; });
        this.aee(a, function (b) { return b.textColor = _this.afu; });
        this.aee(a, function (b) { return b.leftMargin = _this.abk; });
        this.aee(a, function (b) { return b.topMargin = _this.abn; });
        this.aee(a, function (b) { return b.rightMargin = _this.abm; });
        this.aee(a, function (b) { return b.bottomMargin = _this.abj; });
        this.aed(a, function (b) { return b.textStyle = _this.adm; });
        this.aee(a, function (b) { return b.textStyle = _this.aea; });
    };
    RadialBaseChart.prototype.v3 = function (a) {
        var b = this.bi(a);
        var c = this.da(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = this.hw(a);
        if (a.highlightedData != null) {
            c.highlightedItemsSource = this.hx(a);
        }
        c.name = this.qe(a);
        c.title = this.qf(a, b);
        this.dataChart.series.add(c);
    };
    RadialBaseChart.prototype.aej = function (a) {
        this.aek(a, null);
    };
    RadialBaseChart.prototype.aek = function (a, b) {
        a(this.za());
    };
    RadialBaseChart.prototype.aep = function (a, b) {
        a(this.zb());
    };
    RadialBaseChart.prototype.aeo = function (a) {
        this.aep(a, true);
    };
    RadialBaseChart.prototype.ub = function (a, b) {
        this.aej(a);
        this.aep(a, b);
    };
    RadialBaseChart.prototype.aen = function (a) {
        this.aee(this.za(), a);
    };
    RadialBaseChart.prototype.aes = function (a) {
        this.aee(this.zb(), a);
    };
    RadialBaseChart.prototype.aeq = function (a) {
        this.aed(this.zb(), a);
    };
    RadialBaseChart.prototype.ael = function (a) {
        this.aed(this.za(), a);
    };
    RadialBaseChart.prototype.aa3 = function (a) {
        var b = this.za();
        return b.ek(a, new ScalerParams(1, this.yd, this.yc, b.ch));
    };
    RadialBaseChart.prototype.aa5 = function (a) {
        var b = this.za();
        return b.en(a, new ScalerParams(1, this.yd, this.yc, b.ch));
    };
    RadialBaseChart.prototype.aa4 = function (a) {
        var b = this.zb();
        return b.ek(a, new ScalerParams(1, this.yd, this.yc, b.ch));
    };
    RadialBaseChart.prototype.aa6 = function (a) {
        var b = this.zb();
        return b.en(a, new ScalerParams(1, this.yd, this.yc, b.ch));
    };
    RadialBaseChart.prototype.v0 = function (a) {
        _super.prototype.v0.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.za();
            var c = this.zb();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    RadialBaseChart.ac7 = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    RadialBaseChart.prototype.um = function (a, b) {
        _super.prototype.um.call(this, a, b);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.za());
            this.dataChart.axes.add(this.zb());
        }
    };
    RadialBaseChart.prototype.aef = function (a) {
        var _this = this;
        if (a != null && this.lo != null && a.fm == null) {
            a.provideRenderer(this.lo);
        }
        a.jx = this.afi;
        a.es = this.aas;
        a.jy = this.afj;
        a.ev = this.aat;
        a.j0 = this.afl;
        a.fh = this.aau;
        a.jz = this.afk;
        a.fi = this.aav;
        a.j1 = this.afm;
        a.fj = this.aaw;
        a.c4 = true;
        a.cu = this.ha;
        a.cw = this.ha;
        var b = a == this.za();
        if (b) {
            a.g7 = this.acv;
        }
        a.f1 = this.abq;
        a.gh = this.ab7;
        a.ah = this.y6;
        this.aed(a, function (c) { return c.angle = _this.aan; });
        this.aed(a, function (c) {
            if (c.extent != _this.aam) {
                c.extent = _this.aam;
            }
        });
        this.aed(a, function (c) { return c.horizontalAlignment = _this.aew; });
        this.aed(a, function (c) { return c.verticalAlignment = _this.afy; });
        this.aed(a, function (c) { return c.visibility = _this.af3; });
        this.aed(a, function (c) { return c.location = _this.zg(_this.y9); });
        this.aee(a, function (c) { return c.horizontalAlignment = _this.aex; });
        this.aee(a, function (c) { return c.angle = _this.aax; });
        this.aeg(a);
    };
    RadialBaseChart.prototype.aeh = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.lo != null && a.fm == null) {
            a.provideRenderer(this.lo);
        }
        a.cu = this.ha;
        a.cw = this.ha;
        this.aed(a, function (b) { return b.angle = _this.aa8; });
        this.aed(a, function (b) {
            if (b.extent != _this.aa7) {
                b.extent = _this.aa7;
            }
        });
        this.aed(a, function (b) { return b.horizontalAlignment = _this.aey; });
        this.aed(a, function (b) { return b.verticalAlignment = _this.afz; });
        this.aed(a, function (b) { return b.visibility = _this.af4; });
        this.aed(a, function (b) { return b.location = _this.zh(_this.zj); });
        this.aee(a, function (b) { return b.verticalAlignment = _this.af0; });
        this.aee(a, function (b) { return b.angle = _this.abi; });
        a.jx = this.afp;
        a.es = this.abd;
        a.jy = this.afq;
        a.ev = this.abe;
        a.j0 = this.afs;
        a.fh = this.abf;
        a.jz = this.afr;
        a.fi = this.abg;
        a.j1 = this.aft;
        a.fj = this.abh;
        var b = a == this.zb();
        if (b) {
            a.g7 = this.ad1;
        }
        a.gh = this.add;
        a.ah = this.y7;
        this.aei(a);
    };
    RadialBaseChart.prototype.uj = function () {
        _super.prototype.uj.call(this);
        this.aef(this.za());
        this.aeh(this.zb());
    };
    RadialBaseChart.prototype.aed = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.az == null) {
            a.az = new AxisLabelSettings();
            a.az.angle = a.d6();
            a.az.bottomMargin = a.d7();
            a.az.leftMargin = a.d8();
            a.az.rightMargin = a.d9();
            a.az.topMargin = a.ea();
            a.az.horizontalAlignment = a.js();
            a.az.location = a.a0();
            a.az.verticalAlignment = a.kl();
        }
        b(a.az);
    };
    RadialBaseChart.prototype.aee = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bf == null) {
            a.bf = new TitleSettings();
            a.bf.bottomMargin = a.ec();
            a.bf.leftMargin = a.ed();
            a.bf.rightMargin = a.ee();
            a.bf.topMargin = a.ef();
            a.bf.location = a.a1();
            a.bf.angle = a.eb();
            a.bf.horizontalAlignment = a.jt();
            a.bf.verticalAlignment = a.km();
        }
        b(a.bf);
    };
    RadialBaseChart.prototype.vf = function (a, b, c) {
        var _this = this;
        _super.prototype.vf.call(this, a, b, c);
        switch (a) {
            case "AngleAxisLabelAngle":
                this.ael(function (d) { return d.angle = _this.aan; });
                break;
            case "ValueAxisLabelAngle":
                this.aeq(function (d) { return d.angle = _this.aa8; });
                break;
            case "AngleAxisLabelHorizontalAlignment":
                this.ael(function (d) { return d.horizontalAlignment = _this.aew; });
                break;
            case "ValueAxisLabelHorizontalAlignment":
                this.aeq(function (d) { return d.horizontalAlignment = _this.aey; });
                break;
            case "AngleAxisLabelVerticalAlignment":
                this.ael(function (d) { return d.verticalAlignment = _this.afy; });
                break;
            case "ValueAxisLabelVerticalAlignment":
                this.aeq(function (d) { return d.verticalAlignment = _this.afz; });
                break;
            case "AngleAxisLabelVisibility":
                this.ael(function (d) { return d.visibility = _this.af3; });
                break;
            case "ValueAxisLabelVisibility":
                this.aeq(function (d) { return d.visibility = _this.af4; });
                break;
            case "AngleAxisLabel":
                this.aej(function (d) { return d.f1 = _this.abq; });
                break;
            case "ValueAxisLabel":
                this.aeo(function (d) { return d.f1 = _this.abr; });
                break;
            case "AngleAxisLabelFormat":
                this.aej(function (d) { return d.gh = _this.ab7; });
                break;
            case "AngleAxisLabelFormatSpecifiers":
                this.aej(function (d) { return d.ah = _this.y6; });
                break;
            case "ValueAxisLabelFormat":
                this.aeo(function (d) { return d.gh = _this.add; });
                break;
            case "ValueAxisLabelFormatSpecifiers":
                this.aeo(function (d) { return d.ah = _this.y7; });
                break;
            case "AngleAxisTitleAngle":
                this.aen(function (d) { return d.angle = _this.aax; });
                break;
            case "ValueAxisTitleAngle":
                this.aes(function (d) { return d.angle = _this.abi; });
                break;
            case "AngleAxisTitleAlignment":
                this.aen(function (d) { return d.horizontalAlignment = _this.aex; });
                break;
            case "ValueAxisTitleAlignment":
                this.aes(function (d) { return d.verticalAlignment = _this.af0; });
                break;
            case "AngleAxisTitle":
                this.aej(function (d) { return d.g7 = _this.acv; });
                break;
            case "ValueAxisTitle":
                this.aep(function (d) { return d.g7 = _this.ad1; }, false);
                break;
            case "AngleAxisMajorStroke":
                this.aek(function (d) { return d.jx = _this.afi; }, a);
                break;
            case "ValueAxisMajorStroke":
                this.aeo(function (d) { return d.jx = _this.afp; });
                break;
            case "AngleAxisMajorStrokeThickness":
                this.aek(function (d) { return d.es = _this.aas; }, a);
                break;
            case "ValueAxisMajorStrokeThickness":
                this.aeo(function (d) { return d.es = _this.abd; });
                break;
            case "AngleAxisMinorStroke":
                this.aej(function (d) { return d.jy = _this.afj; });
                break;
            case "ValueAxisMinorStroke":
                this.aeo(function (d) { return d.jy = _this.afq; });
                break;
            case "AngleAxisMinorStrokeThickness":
                this.aej(function (d) { return d.ev = _this.aat; });
                break;
            case "ValueAxisMinorStrokeThickness":
                this.aeo(function (d) { return d.ev = _this.abe; });
                break;
            case "AngleAxisTickLength":
                this.aej(function (d) { return d.fi = _this.aav; });
                break;
            case "ValueAxisTickLength":
                this.aeo(function (d) { return d.fi = _this.abg; });
                break;
            case "AngleAxisTickStroke":
                this.aej(function (d) { return d.j1 = _this.afm; });
                break;
            case "ValueAxisTickStroke":
                this.aeo(function (d) { return d.j1 = _this.aft; });
                break;
            case "AngleAxisTickStrokeThickness":
                this.aej(function (d) { return d.fj = _this.aaw; });
                break;
            case "ValueAxisTickStrokeThickness":
                this.aeo(function (d) { return d.fj = _this.abh; });
                break;
            case "AngleAxisStroke":
                this.aej(function (d) { return d.j0 = _this.afl; });
                break;
            case "ValueAxisStroke":
                this.aeo(function (d) { return d.j0 = _this.afs; });
                break;
            case "AngleAxisStrokeThickness":
                this.aej(function (d) { return d.fh = _this.aau; });
                break;
            case "ValueAxisStrokeThickness":
                this.aeo(function (d) { return d.fh = _this.abf; });
                break;
            case "AngleAxisExtent":
                this.ael(function (d) { return d.extent = _this.aam; });
                break;
            case "ValueAxisExtent":
                this.aeq(function (d) { return d.extent = _this.aa7; });
                break;
            case "AngleAxisStrip":
                this.aej(function (d) { return d.jz = _this.afk; });
                break;
            case "ValueAxisStrip":
                this.aeo(function (d) { return d.jz = _this.afr; });
                break;
            case "AngleAxisInverted":
                this.aej(function (d) { return d.ch = _this.zm; });
                break;
            case "ValueAxisInverted":
                this.aeo(function (d) { return d.ch = _this.zn; });
                break;
            case "ValueAxisLabelLocation":
                this.aer();
                break;
            case "AngleAxisLabelLocation":
                this.aem();
                break;
        }
    };
    RadialBaseChart.prototype.aer = function () {
        var a = this.zh(this.zj);
        if (a == 2 || a == 7) {
            this.aey = 2;
        }
        else {
            this.aey = 0;
        }
        this.aeq(function (b) { return b.location = a; });
    };
    RadialBaseChart.prototype.aem = function () {
        var a = this.zg(this.y9);
        if (a == 1 || a == 5) {
            this.afy = 0;
        }
        else {
            this.afy = 2;
        }
        this.ael(function (b) { return b.location = a; });
    };
    RadialBaseChart.prototype.zh = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.b9 == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    RadialBaseChart.prototype.zg = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "abq", {
        get: function () {
            return this.abo;
        },
        set: function (a) {
            var b = this.abq;
            if (a != b) {
                this.abo = a;
                this.vf("AngleAxisLabel", b, this.abq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abr", {
        get: function () {
            return this.abp;
        },
        set: function (a) {
            var b = this.abr;
            if (a != b) {
                this.abp = a;
                this.vf("ValueAxisLabel", b, this.abr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afi", {
        get: function () {
            return this.ae2;
        },
        set: function (a) {
            var b = this.afi;
            if (a != b) {
                this.ae2 = a;
                this.vf("AngleAxisMajorStroke", b, this.afi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afp", {
        get: function () {
            return this.ae9;
        },
        set: function (a) {
            var b = this.afp;
            if (a != b) {
                this.ae9 = a;
                this.vf("ValueAxisMajorStroke", b, this.afp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aas", {
        get: function () {
            return this.zu;
        },
        set: function (a) {
            var b = this.aas;
            if (a != b) {
                this.zu = a;
                this.vf("AngleAxisMajorStrokeThickness", b, this.aas);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abd", {
        get: function () {
            return this.aab;
        },
        set: function (a) {
            var b = this.abd;
            if (a != b) {
                this.aab = a;
                this.vf("ValueAxisMajorStrokeThickness", b, this.abd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aat", {
        get: function () {
            return this.zv;
        },
        set: function (a) {
            var b = this.aat;
            if (a != b) {
                this.zv = a;
                this.vf("AngleAxisMinorStrokeThickness", b, this.aat);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abe", {
        get: function () {
            return this.aac;
        },
        set: function (a) {
            var b = this.abe;
            if (a != b) {
                this.aac = a;
                this.vf("ValueAxisMinorStrokeThickness", b, this.abe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afk", {
        get: function () {
            return this.ae4;
        },
        set: function (a) {
            var b = this.afk;
            if (a != b) {
                this.ae4 = a;
                this.vf("AngleAxisStrip", b, this.afk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afr", {
        get: function () {
            return this.afb;
        },
        set: function (a) {
            var b = this.afr;
            if (a != b) {
                this.afb = a;
                this.vf("ValueAxisStrip", b, this.afr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afl", {
        get: function () {
            return this.ae5;
        },
        set: function (a) {
            var b = this.afl;
            if (a != b) {
                this.ae5 = a;
                this.vf("AngleAxisStroke", b, this.afl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afs", {
        get: function () {
            return this.afc;
        },
        set: function (a) {
            var b = this.afs;
            if (a != b) {
                this.afc = a;
                this.vf("ValueAxisStroke", b, this.afs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aau", {
        get: function () {
            return this.zw;
        },
        set: function (a) {
            var b = this.aau;
            if (a != b) {
                this.zw = a;
                this.vf("AngleAxisStrokeThickness", b, this.aau);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abf", {
        get: function () {
            return this.aad;
        },
        set: function (a) {
            var b = this.abf;
            if (a != b) {
                this.aad = a;
                this.vf("ValueAxisStrokeThickness", b, this.abf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aav", {
        get: function () {
            return this.zx;
        },
        set: function (a) {
            var b = this.aav;
            if (a != b) {
                this.zx = a;
                this.vf("AngleAxisTickLength", b, this.aav);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abg", {
        get: function () {
            return this.aae;
        },
        set: function (a) {
            var b = this.abg;
            if (a != b) {
                this.aae = a;
                this.vf("ValueAxisTickLength", b, this.abg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afm", {
        get: function () {
            return this.ae6;
        },
        set: function (a) {
            var b = this.afm;
            if (a != b) {
                this.ae6 = a;
                this.vf("AngleAxisTickStroke", b, this.afm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aft", {
        get: function () {
            return this.afd;
        },
        set: function (a) {
            var b = this.aft;
            if (a != b) {
                this.afd = a;
                this.vf("ValueAxisTickStroke", b, this.aft);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aaw", {
        get: function () {
            return this.zy;
        },
        set: function (a) {
            var b = this.aaw;
            if (a != b) {
                this.zy = a;
                this.vf("AngleAxisTickStrokeThickness", b, this.aaw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abh", {
        get: function () {
            return this.aaf;
        },
        set: function (a) {
            var b = this.abh;
            if (a != b) {
                this.aaf = a;
                this.vf("ValueAxisTickStrokeThickness", b, this.abh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "acv", {
        get: function () {
            return this.abu;
        },
        set: function (a) {
            var b = this.acv;
            if (a != b) {
                this.abu = a;
                this.vf("AngleAxisTitle", b, this.acv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ad1", {
        get: function () {
            return this.aby;
        },
        set: function (a) {
            var b = this.ad1;
            if (a != b) {
                this.aby = a;
                this.vf("ValueAxisTitle", b, this.ad1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afj", {
        get: function () {
            return this.ae3;
        },
        set: function (a) {
            var b = this.afj;
            if (a != b) {
                this.ae3 = a;
                this.vf("AngleAxisMinorStroke", b, this.afj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afq", {
        get: function () {
            return this.afa;
        },
        set: function (a) {
            var b = this.afq;
            if (a != b) {
                this.afa = a;
                this.vf("ValueAxisMinorStroke", b, this.afq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aan", {
        get: function () {
            return this.zp;
        },
        set: function (a) {
            var b = this.aan;
            if (a != b) {
                this.zp = a;
                this.vf("AngleAxisLabelAngle", b, this.aan);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa8", {
        get: function () {
            return this.z6;
        },
        set: function (a) {
            var b = this.aa8;
            if (a != b) {
                this.z6 = a;
                this.vf("ValueAxisLabelAngle", b, this.aa8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aam", {
        get: function () {
            return this.zo;
        },
        set: function (a) {
            var b = this.aam;
            if (a != b) {
                this.zo = a;
                this.vf("AngleAxisExtent", b, this.aam);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aa7", {
        get: function () {
            return this.z5;
        },
        set: function (a) {
            var b = this.aa7;
            if (a != b) {
                this.z5 = a;
                this.vf("ValueAxisExtent", b, this.aa7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aax", {
        get: function () {
            return this.zz;
        },
        set: function (a) {
            var b = this.aax;
            if (a != b) {
                this.zz = a;
                this.vf("AngleAxisTitleAngle", b, this.aax);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "abi", {
        get: function () {
            return this.aag;
        },
        set: function (a) {
            var b = this.abi;
            if (a != b) {
                this.aag = a;
                this.vf("ValueAxisTitleAngle", b, this.abi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "zm", {
        get: function () {
            return this.zk;
        },
        set: function (a) {
            var b = this.zm;
            if (a != b) {
                this.zk = a;
                this.vf("AngleAxisInverted", b, this.zm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "zn", {
        get: function () {
            return this.zl;
        },
        set: function (a) {
            var b = this.zn;
            if (a != b) {
                this.zl = a;
                this.vf("ValueAxisInverted", b, this.zn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aex", {
        get: function () {
            return this.aeu;
        },
        set: function (a) {
            var b = this.aex;
            if (a != b) {
                this.aeu = a;
                this.vf("AngleAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aex));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "af0", {
        get: function () {
            return this.afx;
        },
        set: function (a) {
            var b = this.af0;
            if (a != b) {
                this.afx = a;
                this.vf("ValueAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.af0));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "aew", {
        get: function () {
            return this.aet;
        },
        set: function (a) {
            var b = this.aew;
            if (a != b) {
                this.aet = a;
                this.vf("AngleAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aew));
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_aey = function () {
        return this.aev;
    };
    RadialBaseChart.prototype.set_aey = function (a) {
        var b = this.aey;
        if (a != b) {
            this.aev = a;
            this.vf("ValueAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aey));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "aey", {
        get: function () {
            return this.get_aey();
        },
        set: function (a) {
            this.set_aey(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afy", {
        get: function () {
            return this.afv;
        },
        set: function (a) {
            var b = this.afy;
            if (a != b) {
                this.afv = a;
                this.vf("AngleAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.afy));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "afz", {
        get: function () {
            return this.afw;
        },
        set: function (a) {
            var b = this.afz;
            if (a != b) {
                this.afw = a;
                this.vf("ValueAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.afz));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "af3", {
        get: function () {
            return this.af1;
        },
        set: function (a) {
            var b = this.af3;
            if (a != b) {
                this.af1 = a;
                this.vf("AngleAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.af3));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "af4", {
        get: function () {
            return this.af2;
        },
        set: function (a) {
            var b = this.af4;
            if (a != b) {
                this.af2 = a;
                this.vf("ValueAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.af4));
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_zj = function () {
        return this.zi;
    };
    RadialBaseChart.prototype.set_zj = function (a) {
        var b = this.zj;
        if (a != b) {
            this.zi = a;
            this.vf("ValueAxisLabelLocation", enumGetBox(ValueAxisLabelLocation_$type, b), enumGetBox(ValueAxisLabelLocation_$type, this.zj));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "zj", {
        get: function () {
            return this.get_zj();
        },
        set: function (a) {
            this.set_zj(a);
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.prototype.get_y9 = function () {
        return this.y8;
    };
    RadialBaseChart.prototype.set_y9 = function (a) {
        var b = this.y9;
        if (a != b) {
            this.y8 = a;
            this.vf("AngleAxisLabelLocation", enumGetBox(AngleAxisLabelLocation_$type, b), enumGetBox(AngleAxisLabelLocation_$type, this.y9));
        }
    };
    Object.defineProperty(RadialBaseChart.prototype, "y9", {
        get: function () {
            return this.get_y9();
        },
        set: function (a) {
            this.set_y9(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "ab7", {
        get: function () {
            return this.abs;
        },
        set: function (a) {
            var b = this.abs;
            if (a != b) {
                this.abs = a;
                this.vf("AngleAxisLabelFormat", b, this.abs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "y6", {
        get: function () {
            return this.y4;
        },
        set: function (a) {
            var b = this.y4;
            if (a != b) {
                this.y4 = a;
                this.vf("AngleAxisLabelFormatSpecifiers", b, this.y4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "add", {
        get: function () {
            return this.abw;
        },
        set: function (a) {
            var b = this.abw;
            if (a != b) {
                this.abw = a;
                this.vf("ValueAxisLabelFormat", b, this.abw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RadialBaseChart.prototype, "y7", {
        get: function () {
            return this.y5;
        },
        set: function (a) {
            var b = this.y5;
            if (a != b) {
                this.y5 = a;
                this.vf("ValueAxisLabelFormatSpecifiers", b, this.y5);
            }
        },
        enumerable: false,
        configurable: true
    });
    RadialBaseChart.$t = markType(RadialBaseChart, 'RadialBaseChart', DomainChart.$);
    return RadialBaseChart;
}(DomainChart));
export { RadialBaseChart };
